//     $Id: global_os.h,v 1.10 2006/01/22 10:33:51 mbickel Exp $
//
//     $Log: global_os.h,v $
//     Revision 1.10  2006/01/22 10:33:51  mbickel
//      Fixed compilation problems with SUSE
//
//     Revision 1.9  2005/04/01 18:59:19  mbickel
//      Applied AMD64 fixes
//
//     Revision 1.8  2004/12/16 10:22:22  mbickel
//      Fixed compilation problems on AMD64 platform
//
//     Revision 1.7  2003/06/01 15:03:16  mbickel
//      Some updates to the build system for FreeBSD
//
//     Revision 1.6  2001/12/14 10:20:06  mbickel
//      Cleanup and enhancements to configure.in
//      Removed last remains of octagonal version from source files
//
//     Revision 1.5  2001/08/07 22:11:05  mbickel
//      Unix build now uses namespace
//      Fixed typo in tutorial
//
//     Revision 1.4  2001/08/07 21:24:36  mbickel
//      Fixed invalid height of planes inside carriers (mapeditor)
//      Added namespace std usage to unix config
//      Updated vehicles (provided by gamer)
//
//     Revision 1.3  2001/07/14 21:07:46  mbickel
//      Sound works now under Win32 too
//      Error reporting on Win32 during startup works again.
//
//     Revision 1.2  2001/05/18 22:30:30  mbickel
//      The data file is now installed in the correct directory
//      If the installation directory is changed with configure, the new path
//       will now be compiled directly into ASC
//
//     Revision 1.1  2000/10/12 21:37:57  mbickel
//      Further restructured platform dependant routines
//
//     Revision 1.1  2000/10/12 20:21:43  mbickel
//      Restructuring operating system dependant files
//
//
/*
    This file is part of Advanced Strategic Command; http://www.asc-hq.de
    Copyright (C) 1994-1999  Martin Bickel  and  Marc Schellenberger

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, write to the 
    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
    Boston, MA  02111-1307  USA
*/

// this file takes care that the necessary header files for opendir / readdir
// are being included in basestrm.cpp

#ifndef global_os_h_included
 #define global_os_h_included

  #include "config.h"  
  // generated by autoconf
   #undef PACKAGE
   #undef VERSION
  
  #define StaticClassVariable

  typedef unsigned long PointerSizedInt;


  #ifdef __cplusplus
   #include <string>  // some Standard library include file to define the namespace std
   using namespace std;
  #endif


  #ifndef HAVE_STRICMP
   #define stricmp strcasecmp
   #define strcmpi strcasecmp
   #define strnicmp strncasecmp
   #define strncmpi strncasecmp
  #endif

  #define CASE_SENSITIVE_FILE_NAMES 1
  #define USE_HOME_DIRECTORY 1


#endif
